% Figure1_2.m
% It requires the following functions:
% eulerE.m
% eulerI.m
% eulerTV.m
% eulerVT.m
% fHO.m
% fHOT.m
% fHOV.m
% fHOEulerE.m
% fHOEulerI.m
% fHOSETV.m
% fHOSEVT.m
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Initial and final time, and  Time step
global h
%t0=0;  tf=8.5;   N=30; %N = 3*6;
t0=0;  tf=2*pi;   N=20; %N = 3*6;
h = (tf-t0)/N;
x0 = [2.5 ; 0];    
q0=x0(1);  p0=x0(2); t = t0; x=x0;
xf=x0';

[t1,xe] = ode45('fHO',[t0,tf],x0);
[t,xee] = ode45('fHOEulerE',[t0,tf],x0);
[t,xei] = ode45('fHOEulerI',[t0,tf],x0);
[t,xtv] = ode45('fHOSETV',[t0,tf],x0);
[t,xvt] = ode45('fHOSEVT',[t0,tf],x0);

[t x1]=eulerE(@fHO,t0,tf,x0,N);
[t x1i]=eulerI(@fHO,t0,tf,x0,N);
[t q1 p1]=eulerTV(@fHOT,@fHOV,t0,tf,q0,p0,N);
[t q2 p2]=eulerVT(@fHOT,@fHOV,t0,tf,q0,p0,N);

figure(1)
 subplot(1,2,1)
  hold on
  plot(xe(:,1),xe(:,2),'k','MarkerSize',8,'LineWidth',2)
  plot(xee(:,1),xee(:,2),'-k','MarkerSize',8,'LineWidth',1)
  plot(x1(:,1),x1(:,2),'ks','MarkerSize',8)
  plot(q1,p1,'ko','MarkerSize',8)
  plot(xtv(:,1),xtv(:,2),'--','LineWidth',1)
  axis equal
  axis([-3 3 -3 3]) 
  xlabel('{\fontsize{14} q }')   
  ylabel('{\fontsize{14} p}','Rotation',0)   
  box

 subplot(1,2,2)
  hold on
  xb=[0.47 1.25 1.25 0.47 0.47];
  yb=[0.1 0.1 -0.9 -0.9 0.1];
  plot(xe(:,1),xe(:,2),'k','MarkerSize',8,'LineWidth',2)
  plot(xei(:,1),xei(:,2),'-k','MarkerSize',8,'LineWidth',1)
  plot(x1i(:,1),x1i(:,2),'ks','MarkerSize',8)
  plot(q2,p2,'ko','MarkerSize',8)
  plot(xvt(:,1),xvt(:,2),'--','LineWidth',1)
  axis equal
  axis([-3 3 -3 3]) 
  xlabel('{\fontsize{14} q }')   
  ylabel('{\fontsize{14} p}','Rotation',0)   
  box
